summaryrefslogtreecommitdiffstats
path: root/office/libreoffice/libreoffice.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'office/libreoffice/libreoffice.SlackBuild')
-rw-r--r--office/libreoffice/libreoffice.SlackBuild182
1 files changed, 182 insertions, 0 deletions
diff --git a/office/libreoffice/libreoffice.SlackBuild b/office/libreoffice/libreoffice.SlackBuild
new file mode 100644
index 0000000000..78f3b0802e
--- /dev/null
+++ b/office/libreoffice/libreoffice.SlackBuild
@@ -0,0 +1,182 @@
+#!/bin/sh
+
+# Slackware build script for LibreOffice
+
+# This is somewhat like a "fork" of the OpenOffice.org script, with permission
+# from its author, Robby Workman
+
+# Copyright 2006,2007,2008,2009,2010 Robby Workman, Northport, Alabama, USA
+# Copyright 2010 Niels Horn, Rio de Janeiro, RJ, Brazil
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Modified by Niels Horn <niels.horn@gmail.com> for LibreOffice
+# Revision date: 2010/09/30
+
+PRGNAM=libreoffice
+VERSION="3.3.0_beta1"
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+SRCVERSION=${VERSION//_/-}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# This should allow you to either pass a different value of LOLANG when you
+# run the script (LOLANG=pt-BR ./libreoffice.SlackBuild for example) or
+# change it in this script. Note that you will need to have the correct
+# tarball in the build directory for this to work...
+# You can get localized tarballs from the following location:
+### --> TODO: No localized versions available yet <-- ###
+# ???://???/$LOLANG/$VERSION/
+# Thanks to Niki Kovacs for finding this :-)
+LOLANG=${LOLANG:-en-US}
+PKG_LANG=${LOLANG//-/_} # Leave this alone
+# Some localized versions only ship with a bundled JRE, and we'd like this
+# script to work on those as well... More importantly, the non-jre tarballs
+# don't seem to hang around on the mirrors for the last two releases, so I'm
+# just going to use the jre-bundled tarballs.
+### --> TODO: Changed default to "no" for now <-- ###
+WJRE=${WJRE:-no}
+
+# If you want to disable java support by removing executable permissions
+# form LibreOffice's java loader (this will not affect other apps), set this
+# variable to "YES" Default is "NO"
+DISABLE_JAVA=${DISABLE_JAVA:-NO}
+
+# Change source package name
+if [ "$ARCH" = "x86_64" ]; then
+ SRCARCH="x86-64"
+ PKGARCH="$ARCH"
+elif [ "$ARCH" = "arm" ]; then
+ printf "\n$ARCH is unsupported for LibreOffice...\n\n"
+ exit 1
+else
+ SRCARCH="x86"
+ PKGARCH="i586"
+fi
+
+# Ignore this - it's just to get the toplevel directory name of the
+# extracted tarball archive
+if [ $WJRE != no ]; then
+ SOURCEDIR=$(tar tzf $CWD/LO_${SRCVERSION}_Linux_${SRCARCH}_install-rpm-wJRE_${LOLANG}.tar.gz 2>/dev/null | head -n 1 | tr -d \/)
+else
+ SOURCEDIR=$(tar tzf $CWD/LO_${SRCVERSION}_Linux_${SRCARCH}_install-rpm_${LOLANG}.tar.gz 2>/dev/null | head -n 1 | tr -d \/)
+fi
+# If the above operation failed for some reason, unset SOURCEDIR so that
+# the "set -eu" below will cause us to bail out with an error
+[ -z $SOURCEDIR ] && unset SOURCEDIR
+
+set -eu
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+rm -rf $TMP/$SOURCEDIR
+
+# Handle the tarballs that include a bundled JRE
+if [ $WJRE != no ]; then
+ tar xvf $CWD/LO_${SRCVERSION}_Linux_${SRCARCH}_install-rpm-wJRE_${LOLANG}.tar.gz -C $TMP
+else
+ tar xvf $CWD/LO_${SRCVERSION}_Linux_${SRCARCH}_install-rpm_${LOLANG}.tar.gz -C $TMP
+fi
+
+# We'll remove this regardless of whether we're using the jre tarball...
+rm -rf $TMP/$SOURCEDIR/{JavaSetup.jar,installdata,setup}
+rm -rf $TMP/$SOURCEDIR/RPMS/{userland,jre-*-linux-*.rpm}
+
+cd $TMP/$SOURCEDIR/RPMS/
+# Yes, I know there is a Slackware integration file in the desktop-integration
+# directory, but it's worthless to us. I'd prefer to do things correctly.
+mv desktop-integration/libreoffice3.3-freedesktop-menus-3.3-9526.noarch.rpm .
+
+# No, I don't want to update our packaged files after the fact
+rm -f *onlineupdate*.rpm # We don't want this
+
+for FILE in *.rpm ; do rpm2cpio < $FILE | cpio -imdv ; done
+rm -rf desktop-integration *.rpm
+mv opt usr $PKG
+cd $PKG
+
+# Kill a broken symlink
+rm -f $PKG/usr/share/applications/libreoffice3-startcenter.desktop
+
+# Create symlinks in /usr/bin to actual binaries
+cd $PKG/usr/bin
+ for FILE in \
+ sbase scalc sdraw simpress smath soffice spadmin swriter unopkg ; do
+ rm -f $FILE
+ ln -sf ../../opt/libreoffice3/program/$FILE $FILE ;
+ done
+cd -
+
+# Remove DejaVu and Liberation fonts - these are included in other packages
+rm -f opt/libreoffice/basis3.3/share/fonts/truetype/[DL]*.ttf
+
+# Fix Exec commands in the desktop files
+# See http://bugzilla.xfce.org/show_bug.cgi?id=2430
+cd $PKG//opt/libreoffice3/share/xdg/
+ for APP in base calc draw impress math writer; do
+ sed -i 's%Exec=libreoffice3 -%Exec=s%' $APP.desktop ;
+ done
+cd -
+
+## Install extensions
+### --> TODO: Doesn't work for now <-- ###
+#UNOPKG_BIN=$PKG/opt/libreoffice3/program/unopkg
+#DICT_DIR=$PKG/opt/libreoffice3/share/extension/install
+#if [ -x "$UNOPKG_BIN" ]; then
+# UNOPKG_TMP=$TMP/$$$$$$
+# find $DICT_DIR -type f -name "*.oxt" \
+# -exec $UNOPKG_BIN add --shared {} \
+# "-env:UserInstallation=file:///$UNOPKG_TMP" \;
+# rm -rf $UNOPKG_TMP # Clean up after ourselves
+#fi
+
+# Move docs to their expected locations
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cd $PKG/opt/libreoffice3
+ mv README* *LICENSE* readmes licenses $PKG/usr/doc/$PRGNAM-$VERSION
+cd -
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# Disable Java support if desired (see above)
+if [ "$DISABLE_JAVA" = "YES" ]; then
+ chmod -x $PKG/opt/libreoffice/ure/bin/javaldx
+fi
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+# Fix ownership and permissions and make the package
+chown -R root:root .
+find . -type d -exec chmod 755 {} \;
+chmod -R u+rw,go+r-w,a-s .
+/sbin/makepkg -c n -l y $OUTPUT/$PRGNAM-${VERSION}_${PKG_LANG}-$PKGARCH-$BUILD$TAG.${PKGTYPE:-tgz}